<?php  if(!defined('PLX_ROOT')) exit;
    
	# Plugin StaticMiniForum V 2.0.1  03/08/2024
	# compatible PHP >= 8.3.0
    # Ajout questions et réponses dans une page statique
    # inscription/connexion des membres
    # Pagination des question/réponses
    # moderation coté visiteurs
    # ajout checkbox, moderation en lot
    # fix compatibilité plugin plxMyBetterUrl
    # @Author Gcyrillus
	# licence GNU General Public License v3.0 : https://github.com/gcyrillus/scripts-pour-pluxml/blob/main/LICENSE
    # $this is $plxShow
    
	# inclusion class du plugin pour extraction des paramètres de configuration
	$plug = $this->plxMotor->plxPlugins->getInstance('StaticMiniForum');	
	#est ce une page statique configurée pour les commentaires ?
	$var['statics']     = $plug->getParam('statics')    == false||null ? '[]': $plug->getParam('statics');
	$var['staticsForm'] = $plug->getParam('staticsForm')== false||null ? '[]': $plug->getParam('staticsForm');
	$staticSelected     = json_decode($var['statics']);
	$staticFormSelected = json_decode($var['staticsForm']);
    $color="green";
	if(is_array($staticSelected) && in_array($this->staticId(), $staticSelected) && str_pad($this->staticId(), 3, '0', STR_PAD_LEFT) != $this->plxMotor->aConf['homestatic']) {
    ?>
    <div id="staticMiniForum">
        <?php
            # affichage du formulaire et commentaires enregistrés.	
            #########################################
            #configuration
            #########################################
            
            
            # nombre de Commentaire à afficher par page
            $bypage  = $plug->getParam('bypage')=='' ? 5: $plug->getParam('bypage');
            
            #  1 au lieu de 0 pour afficher les liens de chaque page
            $intermediaire = $plug->getParam('intermediaire')=='' ? 0: $plug->getParam('intermediaire');
            
            #  1 pour afficher la derniere page des commentaires par défaut
            $showLast = $plug->getParam('showLast')=='' ? 1: $plug->getParam('showLast'); 
            
            #########################################
            # FIN configuration
            #########################################
            
            # fichier de stockage des sujets
            $threadsFile = PLX_ROOT.'/data/statiques/threads-'.$this->staticId().'.json';
            $threadsFileReply = PLX_ROOT.'/data/statiques/threads-'.$this->staticId().'-reply.json';
            if(!file_exists($threadsFile) || strlen(trim(file_get_contents($threadsFile)))<1)  { 
                touch($threadsFile);
                file_put_contents($threadsFile,'[]');
            }
            if(!file_exists($threadsFileReply) || strlen(trim(file_get_contents($threadsFileReply)))<1)  { 
                touch($threadsFileReply);
                file_put_contents($threadsFileReply,'[]');
            }
            #comptage des réponses par sujet
            $numRepliesBySubject = array();
            $replies =  json_decode(file_get_contents($threadsFileReply), true);
            foreach($replies as $k => $v) {
                if(isset($numRepliesBySubject[$v['subject']])) $numRepliesBySubject[$v['subject']] = ++$numRepliesBySubject[$v['subject']];
                else $numRepliesBySubject[$v['subject']] =1;
            }
            if(isset($_GET['replies'])) {
                $subjectRelated =  json_decode(file_get_contents($threadsFile), true);
                foreach($subjectRelated as $index => $array) {
                    if($array['num'] === trim($_GET['replies'])){
                        $subjectRelated = $array;
                        break;
                    }
                }
                $threadsFile = $threadsFileReply;
            } 
            # extraction des commentaires dans un tableau
            $threads =  json_decode(file_get_contents($threadsFile), true);
            # format du message aprés soumission du formulaire 
            $row ='<p id="forum_message" class="#forum_class"><strong>#forum_message</strong></p>';   
            
            ############
			# moderation
            ############
            
			if (isset($_SESSION['profil']) && $_SESSION['profil']=='0' && isset($_POST['delCom']))  { 
				$color = 'green';
                $message='';
				$_SESSION['msgcom'] = $this->getLang('CLEAR').' : '.$plug->getLang('L_NO_THREAD') ;
				foreach ($threads as $subKey => $subArray) { 
                    
					if (in_array($subArray['num'], $_POST["delCom"])) {
                        
                        if(isset($_GET['replies']) &&  trim($subArray['subject']) != trim($_GET['replies'])) continue;
                        
						$message .= $this->getLang('L_THREAD').' #'.
						$subArray['num'].'-'.
						$this->getLang('WRITTEN_BY').' 
						<cite>'.$threads[$subKey]['name'].'</cite> <b>: ' .
						$this->getLang('CLEAR').'</b><br>';
						unset($threads[$subKey]);
                        break;
                    }
                }
				file_put_contents($threadsFile, json_encode($threads,true|JSON_PRETTY_PRINT) );	
				$threads =  json_decode(file_get_contents($threadsFile), true);
                
                if($message !='') $_SESSION['msgcom']=$message;
				$num = count($threads);
            }
            
            
            if(isset($_GET['replies'])) {
                foreach($threads as $k => $post ){
                    if(trim($post['subject']) != trim($_GET['replies']))
                    unset($threads[$k]);
                }  
            }
            $num = count($threads);
			####################################
            # As t-on de nouveaux commentaires ?
			####################################
            
            if(isset($_POST) && is_array($staticFormSelected) &&  in_array($this->staticId(), $staticFormSelected)){
                
                $level='level0';
                if(isset($_POST['name']) AND isset($_POST['content'])) {
                    # color boite message par défaut
					$color = 'orange';
                    if( $_POST['name'] =='' OR $_POST['content'] =='') {
                        $_SESSION['msgcom'] =  L_NEWCOMMENT_FIELDS_REQUIRED;
                    } 
                    else {
                        
                        if(isset($_POST['level'])) 
                        {
                            if(preg_match('/\d/', trim($_POST['level']))) echo '<p>Is DIGITS </p>';
                            $level = trim($_POST['level']) ;
                            if($level == 'level5' || $level =='level-max' ) {$level ='level-max';}
                            else {
                                if(phpversion()>= '8.3.0') {$level= str_increment($level);}
                                else {$level++;}
                            }
                        }            
                        if(isset($_GET['replies']) ) $q = trim($_GET['replies']);  
                        else $q=trim(strip_tags($_POST['subject']));
                        $newpost[] = array(
                        'num'       => trim(strip_tags($_POST['num'])),
                        'subject'   => $q,
                        'level'     => trim(strip_tags($level)),                                
                        'date'      => date('d-m-Y') ,
                        'name'      => trim(strip_tags($_POST['name'])) , 
                        'mail'      => trim(strip_tags($_POST['mail']))  , 
                        'content'   => trim(strip_tags($_POST['content']))
                        );  
                        
                        $color = 'green';
                        $_SESSION['msgcom'] = $plug->getLang('L_THREAD_PUBLISHED');
                        if(isset($_GET['replies'])) $_SESSION['msgcom'] = $plug->getLang('L_REPLY_PUBLISHED');
                        # est ce une reponse ?
                        if(isset($_GET['replies']))$threads= json_decode(file_get_contents($threadsFileReply), true);  
                        
                        array_push($threads,$newpost[0]);
                        
                        file_put_contents($threadsFile, json_encode($threads,true|JSON_PRETTY_PRINT) );  
                        header('location:'.$_SERVER['REQUEST_URI']);
                        exit;
                    }
                }
            }
            
			############################################
			# Quel numero pour le prochain commentaire ?	
			############################################
            
			foreach ($threads as $subKey => $subArray) {
				if(isset($threads[$subKey]['num']) && $num < $threads[$subKey]['num']) $num= $threads[$subKey]['num'];
            }
            
            
            
			###########
            # affichage
			###########
            # Style barre pagination commentaires
            echo '<style>
            :where(.page-item.page-link.active) { text-decoration:underline;font-weight:bold; padding:0.3em 2em;}
            .pagination.text-center.center.bordered {border-radius: 5px;width:max-content;  margin:auto;  border:solid 1px}
            #forum_message:has(strong:empty){display: none;}
            .content_com {  white-space: pre-wrap;}
            #forum_nav {display:flex;place-content:center;gap:.5em;border-block:solid 1px #5558;padding-block:.5em;background:#ADD8E644;font-size:.75em;}
            #forum_nav a {padding:0.05em 1em;border:solid 1px gray;border-radius:7px;background:#059BFF;color:white;} 
            #forum_nav a.reddish {background:#FF4069}
            #modoComs .thread:has(.main_subject) {padding-top:2em;}
            #modoComs .thread:has(.main_subject) label.modo {margin-top:-1.2em;margin-bottom: -1em;}
            .thread:not(:has(.main_subject))  {border:solid 1px;margin-top:.25em}
            .main_subject {border:solid 1px;margin-top:1em;}
            .main_subject  h3 {margin:0;font-size:1.4em;display: grid; grid-template-columns: 1fr auto;gap:1em;padding:.25em .5em;background:ivory;border-bottom: solid 1px}
            .main_subject  h3 :is(time,span) {font-size:1rem;margin:auto 1em auto auto;}
            .main_subject  h3 :is(time,span) b {text-transform: uppercase;color: #ff4069;font-size: 1.75em;}
            h3.miniForum {font-size:1.4em;text-align:center;text-decoration:underline dotted #ff4069 1px;margin-top:3em;}
            .main_subject > div {padding:1em;}
            .named {margin: 0;display: flex;justify-content: space-between;padding-inline: 1em;text-transform: uppercase;background:#f0f0f044;border-bottom:dotted 1px #ccc}
            .named time {font-size: .75em}
            </style>';           
            echo '<nav id="forum_nav">';
            if(!isset($_SESSION['profil'])) echo ' <a href="core/admin/auth.php?newMember=1">S\'inscrire</a> - <a href="core/admin/auth.php">Se connecter</a> ';
            
            else echo '<a href="'. $_SERVER['REQUEST_URI'] .'&backHome">Se déconnecter</a>';
            
            if(isset($_GET['replies'])) echo ' - <a class="reddish" href="'. $this->plxMotor->urlRewrite('?static' . $this->staticId() . '/' . $this->plxMotor->aStats[str_pad($this->staticId(), 3, '0', STR_PAD_LEFT)]['url'] ).'">Retour aux Sujets</a>';
            
            echo'</nav>';
            
            if(isset($_GET['replies'])) { 
                echo '
                <div class="main_subject">
                <h3>'.$subjectRelated['subject'].' <span><b>'.$subjectRelated['name'].'</b> <time date="'.$subjectRelated['date'].'">'.$subjectRelated['date'].'</time></span></h3>             
                <div>'.$subjectRelated['content'].'</div>             
                </div>
                ';
            }
            if(count($threads)>0) {
                if(isset($_GET['replies'])) {
                    $nbitem = $plug->getLang('L_SUBJECT_REPLY');
                    $nbitems = $plug->getLang('L_SUBJECTS_REPLY');
                }
                else {
                    $nbitem = $plug->getLang('L_SUBJECT');
                    $nbitems = $plug->getLang('L_SUBJECTS');
                }
                $tittleThread ="<h3>".count($threads)." ". $nbitem ."</h3>";        
                if(count($threads)>1) {
                    $tittleThread ="<h3>".count($threads)." ".  $nbitems ."</h3>";          
                }
                echo $tittleThread ;
                
                
                
                
                #############################
                # extraction et maj variables
                #############################
                
                # extraction de l'url
                $url = $this->plxMotor->urlRewrite('?static' . $this->staticId() . '/' . $this->plxMotor->aStats[str_pad($this->staticId(), 3, '0', STR_PAD_LEFT)]['url'] );
                $uriRequest = parse_url($_SERVER['REQUEST_URI'])['query'];
                $args= strstr($uriRequest, '&');
                # generation du lien
                $link = $this->plxMotor->urlRewrite($url."/page");
                
                // On calcule le nombre de pages total
                $nbr = count($threads);
                $pages = ceil( $nbr / $bypage);
                $position = 1;
                if($showLast==1) $position = $pages;
                
                # extraction du numéro de page dans l'URL 
                $currentPage = preg_match('#\b/page(\d*)#',$_SERVER["QUERY_STRING"], $capture) ? intval($capture[1]) : $position;
                
                # indice de début, premier article à afficher
                $start = ($currentPage - 1) * $bypage;  
                
                // Calcul du 1er commentaire de la page
                $premier = ($currentPage * $bypage) - $bypage;
                
                $pageThreads = array_slice($threads, $premier, $bypage); 
                
                ###################################################
                # affichage commentaire et formulaire de moderation
                ###################################################
                
                if (isset($_SESSION['profil']) && $_SESSION['profil']=='0')  { echo ' <form method="post" id="modoComs"> '; }            
                foreach($pageThreads as $thread =>$val) { # On boucle sur les sujets   
                    if(isset($val['subject']) && !preg_match('/\d/', $val['subject']) ) {
                        $valsubject='<h3>
                        <a href="'. $_SERVER['REQUEST_URI'].'&replies='.$val['num'].'" title="Voir le sujet :'.$val['subject'].' ">'.$val['subject'].'</a>
                        <span>'.$numRepliesBySubject[$val['num']].' '.$plug->getLang('L_REPLYS').'</span>
                        </h3>';
                        $class='class="main_subject"';
                        
                    } 
                    
                    else {                
                        $valsubject = $class ='';
                    }
                    
                    $index=array_search( $val['num'], array_column( $threads, 'num' ) );
                    echo '<div id="id-'.$val['num'].'" class="thread '.preg_replace('/[^a-zA-Z0-9]/s', '', $val['level']).'">';
					if (isset($_SESSION['profil']) && $_SESSION['profil']=='0')  { echo '<label  class="modo"><input type="checkbox" name="delCom[]" id="#'.$val['num'].'" value="'.$val['num'].'">'.$plug->getLang('L_DELETE').'</label>';}
                    echo '
                    <div id="thread-'.$val['num'].'" data-index="'.$index.'" data-level="'.preg_replace('/[^a-zA-Z0-9]/s', '', $val['level']). '" '.$class.'>
                    '.$valsubject.'
                    <p class="named">'.$val['name'].' <time datetime="'.$val['date'].'">'.$val['date'].'</time> </p>
                    <blockquote><p class="content_thread">'.$val['content'].'</p>
                    </blockquote>';
                    echo '</div>
                    </div>';                
                }
                if (isset($_SESSION['profil']) && $_SESSION['profil']=='0')  { echo '<input type="submit" value="'.$plug->getLang('L_VALID_DELETE').'"></form>';}
                
                ############################
                # Affichage de la pagination
                ############################
                if($pages>1){
                ?>
                <nav>
                    <ul class="pagination text-center center bordered">
                        <!-- Lien vers la page précédente (si on ne se trouve pas sur la 1ère page) -->
                        <?= ($currentPage > 1)  ? "<li class=\"page-item\" ><a href=\"".$link . ($currentPage - 1).$args ."#staticsComments\" class=\"page-link\">".L_PAGINATION_PREVIOUS."</a></li>" : "" ?>
                        
                        <?php if($intermediaire == 1)  {
                        for($page = 1; $page <= $pages; $page++) {
                        # Lien vers chacune des pages (activé si on se trouve sur la page correspondante
                        echo '<li class="page-item ';
                        if($currentPage == $page)  echo 'active';
                        echo "\"><a href=\"".$link.$page.$args ."#staticsComments\" class=\"page-link\">".$page."</a></li>";
                        }
                        }
                        else {
                            echo "<li class=\"page-item page-link  active \">
                            ".$currentPage." / ". $pages."
                            </li>"; 
                            
                        }   ?>
                        <!-- Lien vers la page suivante (si on ne se trouve pas sur la dernière page) -->
                        <?= ($currentPage < $pages) ? " <li class=\"page-item\"><a href=\"".$link.($currentPage + 1 ).$args."#staticsComments\" class=\"page-link\">".L_PAGINATION_NEXT."</a></li>" : "" ?>
                        
                    </ul>
                </nav>
                <?php   }
            }
            else {
                $plug->lang('L_NO_POST');
            }
            
            
            if (!empty($_SESSION['msgcom'])) {
                $message=$_SESSION['msgcom'];
                $color="green";
                $row = str_replace('#forum_class', 'alert ' . $color, $row);
                unset($_SESSION['msgcom']);
            }
            else {
                $message='';
                
            }
            $row = str_replace('#forum_message',$message , $row);
            
            if(is_array($staticFormSelected) && in_array($this->staticId(), $staticFormSelected)) {
                if(isset($_SESSION['profil'])) {
                ?>
                <script>
                    const myformtpl =`
                    <template id="myform">
                    <h3 class="miniForum">
                    <?php if(!isset($_GET['replies'])) {
                        $plug->lang('WRITE_A_THREAD');
                        $txt_content = $plug->getLang('SUBJECT_CONTENT');
                    }
                    else {
                        $plug->lang('SUBJECT_REPLY'); 
                        $txt_content = $plug->getLang('SUBJECT_CONTENT_REPLY');
                        $threadId= trim($_GET['replies']);
                    }?>
                </h3>
                <form id="form" action="<?php echo $_SERVER['REQUEST_URI']; ?>#form" method="post">
                    <?= $row;  ?>
                    <fieldset>
                        <?php  if(!isset($_GET['replies'])) { ?>
                            <div class="grid">
                                <div class="col sml-12">
                                    <label for="id_subject"><?php $plug->lang('SUBJECT') ?>* :</label>
                                    <input id="id_subject" name="subject" type="text" size="20" value="" maxlength="30" required="required" />
                                </div>
                            </div>  
                        <?php } ?>
                        <div class="grid">
                            <div class="col sml-12">
                                <div id="id_answer"></div>
                                <label for="id_content" class="lab_com"><?= $txt_content ?>* :</label>
                                <textarea id="id_content" name="content" cols="35" rows="6" required="required"></textarea>
                            </div>
                        </div>
                        <div class="grid">
                            <div class="col sml-12 med-6">
                                <label for="id_name"><?php $this->lang('NAME') ?>* :</label>
                                <input id="id_name" name="name" type="text" size="20" maxlength="30" required="required" value="<?= $this->plxMotor->aUsers[$_SESSION["user"]]["name"] ?>" />
                            </div>
                            <div class="col sml-12 med-6">
                                <label for="id_mail"><?php $this->lang('EMAIL') ?> :</label>
                                <input id="id_mail" name="mail" type="text" size="20" value="<?= $this->plxMotor->aUsers[$_SESSION["user"]]["email"] ?>" />
                            </div>
                        </div>
                        
                        <div class="grid">
                            <div class="col sml-12">
                                <input type="hidden" id="num" name="num" value="<?php 
                                    if ($num == 0 ) $num = 1;
                                    else ++$num ;
                                echo $num; ?>"/>
                                <input type="hidden" id="id_parent" name="parent" value="" />
                                <input class="blue" type="submit" value="<?php $this->lang('SEND') ?>" />
                            </div>
                        </div>
                        
                    </fieldset>
                    
                </form>
            </template>`;
        </script>
        <?php }
        else { ?>
        <script>
            const myformtpl =``;
        </script>
    <?php   } } ?>
    
    <script>
        window.addEventListener("load", (event) => {
            document.body.insertAdjacentHTML( 'afterbegin', myformtpl);
            const MyForm =document.querySelector('#staticMiniForum');
            let template = document.getElementById("myform");
            let templateContent = template.content;
            MyForm.appendChild(templateContent);
        });
    </script>
    
</div>
<?php } ?>